;
; HelloWord demo - V20-MBC (HW ref: A250220)
;
; REQUIRED: IOS S260320 (or following revisions until otherwise stated)
;
; Assemble with "nasm -f bin  filename.asm -o filename.bin"
;
;

    CPU     8086        ; Set 8086/8088 opcodes only
    BITS    16          ; Set default 16 bit

eos         equ    0x00    ; End of string
    
; IOS equates
EXC_WR_OPCD equ    0x00      ; Address of the EXECUTE WRITE OPCODE write port
EXC_RD_OPCD equ    0x00      ; Address of the EXECUTE READ OPCODE read port
STO_OPCD    equ    0x01      ; Address of the STORE OPCODE write port
SERIAL_RX   equ    0x01      ; Address of the SERIAL RX read port
SYSFLAGS    equ    0x02      ; Address of the SYSFLAGS read port
SERTX_OPC   equ    0x01      ; SERIAL TX opcode

    org  0
    ;
    ; Init
    ;
    mov     ax, cs          ; DS = SS = CS
    mov     ds, ax
    mov     ss, ax
    mov     sp, stack       ; Set the stack
    ;
    ; Print a message and halt
    ;
    mov     bx, msg
    call    puts
halt:
    hlt
    jmp     halt
    
; =========================================================================== ;
;
; Send a string to the serial line, DX contains the pointer to the string.
; NOTE: Only AL and BX are used
;
; =========================================================================== ;
puts:
    mov     al, [bx]        ; AL = current char to print
    cmp     al, eos         ; End of string reached?
    jz      puts_end        ; Yes, jump
    mov     al, SERTX_OPC   ; AL = SERIAL TX opcode
    out     STO_OPCD, al    ; Write the opcode
    mov     al, [bx]        ; AL = current char to print
    out     EXC_WR_OPCD, al ; Print AL
    inc     bx              ; Increment character pointer
    jmp     puts            ; Transmit next character
    
puts_end:
    ret
    
    
msg     db  'Hello, World!', 0x0d, 0x0a, eos    ; 0x00 is the message terminator
        times   0x100   db  0;
stack: