@echo off
rem            ----------------------------------------------------------------------------
rem
rem            AL.BAT - Assemble and load a source file using the NASM assembler 
rem                     and Tera Term.
rem
rem            USAGE:      AL <source_file.asm>
rem
rem            ----------------------------------------------------------------------------
rem
rem            NOTE 1: NASM and Tera Term must be already installed in your system.
rem
rem            NOTE 2: NASM (nasm.exe) must be already added to your PATH system variable.
rem
rem            NOTE 3: The macro file LoadV20.ttl must be adapted to your system ad copied
rem                    into the Tera Term installation directory.
rem
rem            ----------------------------------------------------------------------------
rem                                                           by J4F
rem
if .%1==. goto :error2
set scfile=%1
if not exist %scfile% goto :error1
nasm -f ith %scfile% -l out.lst -o out.hex
rem tasm -s -h -c -g0 -85  %scfile% out.hex
if not %ERRORLEVEL%==0 goto :error3
echo No Assembler errors. Output file: out.hex
copy /y out.hex load.hex > nul
echo * * * Remember to close the Tera Term window before a new upload! * * *
rem
rem ******************************************************************************
rem *                                                                            *
rem * * *   Change the following line according to your installation!!!!!!   * * * 
rem *                                                                            *
rem *     NOTE: /c=5 means COM5 is used for the USB-serial adapter;              *
rem *           "C:\Program Files (x86)\teraterm\ttermpro.exe" is where Tera Term*
rem *           is installed in your system.                                     *
rem *                                                                            *
"C:\Program Files (x86)\teraterm\ttermpro.exe" /c=5 /BAUD=115200 /w="V20-MBC Terminal" /m=LoadV20.ttl
rem *                                                                            *
rem ******************************************************************************
rem
echo All done. Bye bye...
goto :end

:error3
echo Errors found in source file %scfile% during Assembler compilation.
echo Nothing to load to the target!
goto :end

:error2
echo Please specify a source file!
echo Usage: AL ^<source_file.asm^>
goto :end

:error1
echo Error: file %scfile% not found!

:end